classDisplayName, class, classID = UnitClass("player");

----------------------------------------------------------------------------------------------------
---------------------------------------Sound Files--------------------------------------------------
----------------------------------------------------------------------------------------------------

deadsounds = {
	"Interface\\AddOns\\GameDouble\\Audio\\dead\\dead1.ogg",
	"Interface\\AddOns\\GameDouble\\Audio\\dead\\dead2.ogg",
	"Interface\\AddOns\\GameDouble\\Audio\\dead\\dead3.ogg",
	"Interface\\AddOns\\GameDouble\\Audio\\dead\\dead4.ogg"
}

-----------------------------------------------------------------------------------------------------
--------------------------------------Initialization-------------------------------------------------
-----------------------------------------------------------------------------------------------------

local automation = CreateFrame("Frame")
local firstrun = CreateFrame("Frame")
firstrun:RegisterEvent("ADDON_LOADED")
automation:RegisterEvent("ZONE_CHANGED_NEW_AREA")
automation:RegisterEvent("COMMENTATOR_ENTER_WORLD")
automation:RegisterEvent("PLAYER_REGEN_DISABLED")
automation:RegisterEvent("UNIT_EXITED_VEHICLE")
automation:RegisterEvent("UNIT_ENTERED_VEHICLE")
firstrun:SetScript("OnEvent", function(self, event, arg1)
    if event == "ADDON_LOADED" and arg1 == "GameDouble" then
        if AutomaticActivation == nil then
            AutomaticActivation = 0;
        end
		if DeaderThanDead == nil then
            DeaderThanDead = 0;
        end
	end
end)

----------------------------------------------------------------------------------------------------
----------------------------------------Play Death Sounds-------------------------------------------
----------------------------------------------------------------------------------------------------

local PSF = PlaySoundFile
local deadframe = CreateFrame("FRAME");
local guid = UnitGUID("unit")
-- local className, classId, raceName, raceId, gender, name, realm = GetPlayerInfoByGUID("player")
deadframe:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
deadframe:SetScript("OnEvent", function(self, event, ...)
	if DeaderThanDead == 2 then
		if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
			local type = select(2, ...)
			if (type == "UNIT_DIED") then
				PSF(deadsounds[(math.random(1,3))], "Master")
			end
		end
	end
	if DeaderThanDead == 1 then
		if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
			local type = select(2, ...)
			local destName = select(9, ...)
			local sourceName = select(5, ...)
			if (type == "SWING_DAMAGE") then
				local overkill = select(13, ...)
				if overkill >=0 and destName ~= "Training Dummy" then
					if sourceName == UnitName("player") then
						PSF(deadsounds[(math.random(1,3))], "Master")
					end
				end
			end
			if (type == "SPELL_DAMAGE") then
				local overkill = select(16, ...)
				if destName ~= "Training Dummy" then
					if overkill >=0 then
						if sourceName == UnitName("player") then
							PSF(deadsounds[(math.random(1,3))], "Master")
						end
					end	
				end
			end
			if (type == "SPELL_PERIODIC_DAMAGE") then
				local overkill = select(16, ...)
				if destName ~= "Training Dummy" then
					if overkill >=0 then
						if sourceName == UnitName("player") then
							PSF(deadsounds[(math.random(1,3))], "Master")
						end
					end	
				end
			end
			if (type == "RANGE_DAMAGE") then
				local overkill = select(16, ...)
				if destName ~= "Training Dummy" then
					if overkill >=0 then
						if sourceName == UnitName("player") then
							PSF(deadsounds[(math.random(1,3))], "Master")
						end
					end	
				end
			end
		end
	end
end)

----------------------------------------------------------------------------------------------------
----------------------------------------Automatic Updates-------------------------------------------
----------------------------------------------------------------------------------------------------

automation:SetScript("OnEvent", function(self, event)
	if event == "ZONE_CHANGED_NEW_AREA" or "COMMENTATOR_ENTER_WORLD" or "PLAYER_REGEN_DISABLED"  or "UNIT_EXITED_VEHICLE" or "UNIT_ENTERED_VEHICLE" then
        if AutomaticActivation == 1 then
			MainMenuBarLeftEndCap:Hide()
			MainMenuBarRightEndCap:Hide()
			if classID == 11 then do --druid
				EclipseBarFrame:ClearAllPoints()
				EclipseBarFrame:SetPoint("CENTER", UIParent, "CENTER", 0, -100)
				EclipseBarFrame:SetScale(1.7)
			end
			elseif classID == 10 then do --monk
			end
			elseif classID == 9 then do --warlock
				WarlockPowerFrame:ClearAllPoints()
				WarlockPowerFrame:SetPoint("CENTER", UIParent, "CENTER", 0, -100)
				WarlockPowerFrame:SetScale(1.7)
			end
			elseif classID == 8 then do --mage
			end
			elseif classID == 7 then do --shaman
			end
			elseif classID == 6 then do --deathknight
				PlayerFrameManaBar:SetScale(1.75)
				PlayerFrameManaBar:ClearAllPoints()
				PlayerFrameManaBar:SetPoint("CENTER", UIParent, "CENTER", -4, -80)
				RuneFrame:SetScale(1.7)
				RuneFrame:ClearAllPoints()
				RuneFrame:SetPoint("CENTER", UIParent, "CENTER", 0, -100)
			end
			elseif classID == 5 then do --priest
			end
			elseif classID == 4 then do --rogue
			end
			elseif classID == 3 then do --hunter
			end
			elseif classID == 2 then do --paladin
				PaladinPowerBar:ClearAllPoints()
				PaladinPowerBar:SetPoint("CENTER",UIParent,"CENTER",0,-100)
				PaladinPowerBar:SetScale(1.7)
			end
			elseif classID == 1 then do --warrior
			PlayerFrameManaBar:SetScale(1.75)
			PlayerFrameManaBar:ClearAllPoints()
			PlayerFrameManaBar:SetPoint("CENTER", UIParent, "CENTER", -4, -80)
			end
		end
	end
	end
end)

----------------------------------------------------------------------------------------------------
-------------------------------------------Slash Commands-------------------------------------------
----------------------------------------------------------------------------------------------------

SLASH_GAMEDOUBLE1, SLASH_GAMEDOUBLE2 = '/gamedouble', '/gd';
local function handler(msg, editBox)
	if msg == 'dead' then
		if DeaderThanDead == 0 then
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Announce your kills")
			DeaderThanDead = DeaderThanDead + 1
		elseif DeaderThanDead == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Announce all kills")
			DeaderThanDead = DeaderThanDead + 1
		elseif DeaderThanDead == 2 then 
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Announce kills disabled")
			DeaderThanDead = DeaderThanDead - 2
		end
	end
	if msg == 'auto' then
		if AutomaticActivation == 0 then
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Automatic activation on")
			AutomaticActivation = AutomaticActivation + 1
		elseif AutomaticActivation == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Automatic activation off")
			AutomaticActivation = AutomaticActivation - 1
		end
	end
	if msg == 'speech' then
			SendChatMessage("Sons of Orgrimmar! Of the Horde! My brothers. I see in your eyes the same fear that would take the heart of me. A day may come when the courage of Orcs fails, when we forsake our friends and break all bonds of fellowship, but it is not this day.",YELL)
			SendChatMessage("An hour of wolves and shattered shields when the Age of Orcs comes crashing down, but it is not this day! This day we fight! By all that you hold dear on this good Azeroth, I bid you stand, Warriors of the Horde!",YELL)
		end
	if msg == '' then
		DEFAULT_CHAT_FRAME:AddMessage("List of current commands:")
		DEFAULT_CHAT_FRAME:AddMessage("/gd auto   - Toggles automatic activation")
		DEFAULT_CHAT_FRAME:AddMessage("/gd dead   - Plays sounds on kills")
		DEFAULT_CHAT_FRAME:AddMessage("/gd speech - Provide your teammates with a motivation speech")
		DEFAULT_CHAT_FRAME:AddMessage("/gd run    - Run the addon")
	end
	if msg == 'run' then
		DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Configured for "..classDisplayName)
		MainMenuBarLeftEndCap:Hide()
		MainMenuBarRightEndCap:Hide()
		if classID == 11 then do --druid
			EclipseBarFrame:ClearAllPoints()
			EclipseBarFrame:SetPoint("CENTER", UIParent, "CENTER", 0, -100)
			EclipseBarFrame:SetScale(1.7)
		end
		elseif classID == 10 then do --monk
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Class not fully configured")
		end
		elseif classID == 9 then do --warlock
			WarlockPowerFrame:ClearAllPoints()
			WarlockPowerFrame:SetPoint("CENTER", UIParent, "CENTER", 0, -100)
			WarlockPowerFrame:SetScale(1.7)
		end
		elseif classID == 8 then do --mage
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Class not fully configured")
		end
		elseif classID == 7 then do --shaman
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Class not fully configured")
		end
		elseif classID == 6 then do --deathknight
			PlayerFrameManaBar:SetScale(1.75)
			PlayerFrameManaBar:ClearAllPoints()
			PlayerFrameManaBar:SetPoint("CENTER", UIParent, "CENTER", -4, -80)
			RuneFrame:SetScale(1.7)
			RuneFrame:ClearAllPoints()
			RuneFrame:SetPoint("CENTER", UIParent, "CENTER", 0, -100)
		end
		elseif classID == 5 then do --priest
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Class not fully configured")
		end
		elseif classID == 4 then do --rogue
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Class not fully configured")
		end
		elseif classID == 3 then do --hunter
			DEFAULT_CHAT_FRAME:AddMessage("GameDouble UI Addon: Class not fully configured")
		end
		elseif classID == 2 then do --paladin
			PaladinPowerBar:ClearAllPoints()
			PaladinPowerBar:SetPoint("CENTER",UIParent,"CENTER",0,-100)
			PaladinPowerBar:SetScale(1.7)
		end
		elseif classID == 1 then do --warrior
			PlayerFrameManaBar:SetScale(1.75)
			PlayerFrameManaBar:ClearAllPoints()
			PlayerFrameManaBar:SetPoint("CENTER", UIParent, "CENTER", -4, -80)
		end
	end
end
end
SlashCmdList["GAMEDOUBLE"] = handler;